package com.nisum.ecomservice.controller;

import com.nisum.ecomservice.dto.CartDTO;
import com.nisum.ecomservice.dto.Order;
import com.nisum.ecomservice.dto.OrderRequest;
import com.nisum.ecomservice.service.OrderService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

@RestController
@RequestMapping("/api/orders")
@CrossOrigin(origins = "*")
public class OrdersController {
    @Autowired
    private OrderService orderService;

    @PostMapping
    private Mono<Order> postOrder(@RequestBody OrderRequest orderRequest){
        return orderService.postOrder(orderRequest);
    }
    @GetMapping("/byUser/{userId}")
    private ResponseEntity<Flux<Order>> getUserOrderHistory(@PathVariable String userId){
        return ResponseEntity.ok(orderService.getOrderFromOmsAPI(userId));
    }

}
