package com.nisum.ecomservice.controller;

//import com.google.api.client.googleapis.auth.oauth2.GoogleIdTokenVerifier;
//import com.google.api.client.http.javanet.NetHttpTransport;
//import com.google.api.client.json.gson.GsonFactory;
import com.nisum.ecomservice.model.User;
import com.nisum.ecomservice.model.UserRequestBody;
import com.nisum.ecomservice.service.UserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

import java.util.Collections;

@RestController
@RequestMapping("/api/users")
@CrossOrigin(origins = "*")
public class UsersController {
    @Autowired
    private UserService userService;

//    @Value("${google.client_id}")
//    private String CLIENT_ID;

//    NetHttpTransport transport = new NetHttpTransport();
//    GsonFactory jsonFactory = new GsonFactory().getDefaultInstance();
//
//    GoogleIdTokenVerifier verifier = new GoogleIdTokenVerifier.Builder(transport, jsonFactory)
//            // Specify the CLIENT_ID of the app that accesses the backend:
//            .setAudience(Collections.singletonList(CLIENT_ID))
//            // Or, if multiple clients access the backend:
//            //.setAudience(Arrays.asList(CLIENT_ID_1, CLIENT_ID_2, CLIENT_ID_3))
//            .build();

    @GetMapping()
    private Flux<User> getUsers(){
        System.out.println(
                "get users"
        );
        return userService.getUsers();
    }

    @PostMapping()
    public ResponseEntity<Mono<User>> createUser(@RequestBody UserRequestBody requestBody) {

//        GoogleIdToken idToken = verifier.verify(idTokenString);
//        if (idToken != null) {
//            Payload payload = idToken.getPayload();
//            String userId = payload.getSubject();
////          System.out.println("User ID: " + userId);
//            // Get profile information from payload
//            String email = payload.getEmail();
//            boolean emailVerified = Boolean.valueOf(payload.getEmailVerified());
//            String lastName = (String) payload.get("family_name");
//            String firstName = (String) payload.get("given_name");
//
//            User newUser = null;
//            newUser.setUserId(userId);
//            newUser.setEmail(email);
//            newUser.setFirstName(firstName);
//            newUser.setLastName(lastName);
//            newUser.setAccessToken(accessTokenString);
//
//            return ResponseEntity.ok(userService.getUserbyEmail(email).switchIfEmpty(userService.createUser(newUser)));
//        } else {
//            return new ResponseEntity<>(HttpStatus.BAD_REQUEST);
//        }

        String idTokenString = requestBody.getIdToken();

        User newUser = new User(requestBody.getUserId(), requestBody.getEmail(), requestBody.getFirstName(), requestBody.getLastName(), requestBody.getAccessToken());

        Mono<Boolean> response = userService.verifyToken(idTokenString);

        Mono<User> newUserMono = response.flatMap(res-> {
            if(res){
                return userService.createUser(newUser);
            }else{
                return Mono.empty();
            }
        });

        return ResponseEntity.ok(newUserMono);
    }
}

