import React, { Component } from 'react'
import Nav from 'react-bootstrap/Nav'
import Navbar from 'react-bootstrap/Navbar'
import NavDropdown from 'react-bootstrap/NavDropdown'
import {NavLink} from 'react-router-dom'
import Session from '../session/session-container'
import HeaderCart from './header-cart-container'

import './header.css';

export default class Header extends Component {
    constructor(props) {
        super(props)
        this.state = {}
    }

    render() {
        let userName
        if(!!this.props.user?.currentUser){
            userName = this.props.user.currentUser.firstName
        }else{
            userName = "Guest"
        }

        return (
            <div>
                <Navbar className = "header-nav" collapseOnSelect expand="sm" bg="light">
                    <Navbar.Brand>Ascend Ecommerce</Navbar.Brand>
                    <Navbar.Toggle aria-controls="responsive-navbar-nav" />
                    <Navbar.Collapse id="responsive-navbar-nav">
                        <Nav className="mr-auto">
                            <Nav.Link to="/product-market" id="nav-home-link">Home</Nav.Link>
                            <Nav.Link to="/product-market">Products</Nav.Link>
                        </Nav>
                        <Nav className="ms-auto">
                            {!this.props.user?.currentUser ? 
                                <Navbar.Text className="nav-bar-text">Hello Guest</Navbar.Text> :
                                <NavDropdown className="nav-bar-text" title={"Hello "+userName} id="collasible-nav-dropdown">
                                    <NavDropdown.Item ><NavLink to="/orders">Order History</NavLink></NavDropdown.Item>
                                </NavDropdown>
                            }
                            <Session className="nav-bar-text"/>
                            <HeaderCart className="nav-bar-text"/>
                        </Nav>
                    </Navbar.Collapse>
                </Navbar>
            </div>
        )
    }
}

