import React from 'react';
import { totalPrice } from '../../util/order_history_util';
import OrderItem from './OrderItem';


const Order = (props) => {

    const {order} = props;
    const {orderItems, customerAddress} = order;

    const orderTotalPrice = totalPrice(orderItems);
    const orderPlaced = new Date(order.orderCreatedAt);

    return (
        <div className="order">
            <p><span className="order-field">Order ID:</span> {order.id}</p>
            <p><span className="order-field">Order Status:</span> {order.orderStatus}</p>
            <p><span className="order-field">Order Placed:</span> {orderPlaced.getUTCMonth()}
                /{orderPlaced.getUTCDay()}
                /{orderPlaced.getUTCFullYear()}
            </p>
            <p>
            <span className="order-field">Delivery Address:</span> {`
                ${customerAddress.street},
                ${customerAddress.city},
                ${customerAddress.state} ${customerAddress.zip}
                `}
            </p>
            <p><span className="order-field">Items Ordered:</span></p>
            <div className="products-ordered">
                {orderItems.map((orderItem, ind) => {
                    return (
                        <OrderItem key={ind} orderItem={orderItem} />
                    )
                })}
            </div>
            <p><span className="order-field">Total Price:</span> ${orderTotalPrice}</p>

        </div>
    )
}

export default Order;