import React, { useEffect, useState } from 'react'
import { useDispatch, useSelector } from 'react-redux';
import { dispatchOrderHistory } from '../../actions/order_history_actions';
import { getOrderHistory } from '../../util/order_api_util';
import Order from './Order';

import './order-history.css'

const OrderHistory = () => {

    const dispatch = useDispatch();

    const user = useSelector(state => state.user);
    const {orderHistory} = useSelector(state => state.orderStatus)

    //const [callMade, setCallMade] = useState(false);
    
    useEffect( async () => {
        if (!user) return;
        if (!user.currentUser) return;
        dispatch(dispatchOrderHistory(user.currentUser.userId));
        //setCallMade(true);
    }, [user]);

    return (
        <main>
            <h1 id="order-history-header">Order History</h1>
            {user === null ? (
                <div>Please login to place orders!</div>
            ) : null}
            <div id="orders">
                {orderHistory.map(order => {
                    return <Order order={order}/>;
                })}
            </div>
        </main>
    )
}

export default OrderHistory;