import { connect } from 'react-redux';
import ProductMarket from './product-market';
import { fetchProducts, fetchPromotions } from '../../actions/product_actions';
import { fetchUserCart, updateUserCart } from '../../actions/cart_actions';

const mSTP = state => ({
  products: state.market.products,
  promotions: state.market.promotions,
  user: state.user,
  cart: state.cart
});

const mDTP = dispatch => ({
  getProducts: () => dispatch(fetchProducts()),
  getPromotions: () => dispatch(fetchPromotions()),
  getUserCart: userId => dispatch(fetchUserCart(userId)),
  addCartItem: (updatedCart, userEmail) => dispatch(updateUserCart(updatedCart, userEmail))
});

export default connect(mSTP, mDTP)(ProductMarket);