import React, { Component } from 'react'
import ProductItem from './product-item'
import '../../resources/stylesheets/product-market.css';
import '../../resources/stylesheets/reset.css';



export default class ProductMarket extends Component {
  constructor(props) {
    super(props)
    this.state = {}
  }

  componentDidMount() {
    this.props.getProducts();
    this.props.getPromotions();
  }
  
  render() {
    let products = this.props.products;
    let promotions = this.props.promotions;
    
    products.forEach(prod => {
      promotions.forEach(promo => {
        if (prod.sku === promo.productSku) {
          prod.promo = (promo.discountPercentage);
        }
      });
    });
    
    return (
      <div className="product-market-container">
        <div id="product-market-title">
          <p>
            Product Market
          </p>
        </div>
        <div className="products-container">
          {this.props.products.map(prod => {
            return (
              <div className={prod.availableStock >= 0 ? "product-item-container" : "no-item"} key={ prod.sku }>
                { prod.availableStock >= 0 ? "" : <p id="out-of-stock">- Out of Stock -</p> }
                { prod.productName ? 
                  <ProductItem 
                    item={ prod } 
                    cart={ this.props.cart } 
                    user={ this.props.user } 
                    addToCart={ this.props.addCartItem }
                  />
                  :
                  <div className="product-item">
                    <p id="prod-not-available">This Product is No Longer Available</p>
                  </div> 
                }
              </div>
            )
          })}
        </div>
      </div>
    )
  }
}
