import { connect } from 'react-redux';
import Session from './session';
import {login, logOut} from '../../actions/session_actions';
import { fetchUserCart, createUserCart, clearUserCart } from '../../actions/cart_actions';

const mSTP = state => ({
    currentUser: state.user
});

const mDTP = dispatch => ({
    login: (userResponse) => dispatch(login(userResponse)),
    logOut: () => dispatch(logOut()),
    getUserCart: userId => dispatch(fetchUserCart(userId)),
    createCart: newCart => dispatch(createUserCart(newCart)),
    clearCart: () => dispatch(clearUserCart())
});

export default connect(mSTP, mDTP)(Session);